// Generated by CoffeeScript 2.2.3
(function() {
  var $, ChildProcess, Fs, basePath, cmd, createBasePath, echo, exists, expandPath, makePath, seekForBasePath, verbose, warn;

  ({$, cmd, echo, warn, verbose} = require('./common'));

  Fs = require('fs');

  ChildProcess = require('child_process');

  expandPath = (s) => {
    return s.replace(/^~/, process.env.HOME).replace(/^%/, basePath);
  };

  exists = (p) => {
    try {
      Fs.accessSync(expandPath(p, Fs.constants.R_OK));
      return true;
    } catch (error) {}
    return false;
  };

  seekForBasePath = () => {
    var path, paths;
    paths = $(process.cwd().split('/'));
    while (paths.length > 0) {
      path = paths.join('/') + '/.shepherd';
      if (exists(path)) {
        return path;
      }
      paths.pop();
    }
  };

  if ("SHEPHERD_HOME" in process.env) {
    basePath = process.env.SHEPHERD_HOME;
  } else {
    if (cmd.base != null) {
      basePath = cmd.base + "/.shepherd";
    } else {
      basePath = seekForBasePath();
    }
  }

  exists(basePath) && verbose("Using", basePath);

  createBasePath = (prefix, cb) => {
    return ChildProcess.spawn(`mkdir -p "${prefix}/.shepherd"`, {
      shell: true
    }).on('exit', () => {
      echo("Created .shepherd folder...");
      return cb();
    });
  };

  makePath = (...parts) => {
    var ret;
    if (basePath == null) {
      return void 0;
    } else {
      ret = [basePath].concat(parts).join("/").replace(/\/\//g, '/');
      if (ret.indexOf(process.env.HOME) === 0) {
        ret = ret.replace(process.env.HOME, '~');
      } else if (ret.indexOf(basePath) === 0) {
        ret = ret.replace(basePath, '%');
      }
      return ret;
    }
  };

  Object.assign(module.exports, {
    createBasePath,
    exists,
    makePath,
    basePath,
    expandPath,
    exists: exists,
    pidFile: makePath("pid"),
    socketFile: makePath("socket"),
    configFile: makePath("config"),
    nginxFile: makePath("nginx"),
    nginxTemplate: makePath("nginx.template"),
    outputFile: makePath("log")
  });

}).call(this);
